
var debug = require('debug')('normalize-proxy:resolve:resolve')
var EventEmitter = require('events').EventEmitter

var uris = require('../uri')

module.exports = resolve

/**
 * Locking mechanism for installs so that only one
 * install occurs at a time. Only valid per-process,
 * obviously, so you should avoid creating multi-process proxies.
 */

var ee = resolve.ee = new EventEmitter()
ee.setMaxListeners(0)

resolve.installing = Object.create(null)
resolve.await = require('await-event').bind(ee)
resolve.emit = ee.emit.bind(ee)

function resolve(uri) {
  if (!Array.isArray(uri)) uri = uris.parseRemote(uri)
  debug('resolving %o', uri)

  var remote = uri[0]
  uri[3] = decodeURIComponent(uri[3]) // decode the semver range
  if (remote.git) return resolve.git(uri)
  return resolve.npm(uri)
}
